#ifndef WALLWINDOW_H
#define WALLWINDOW_H

#include <QDialog>
#include <QFileDialog>
#include <QSystemTrayIcon>
#include <QSettings>
#include <QtGui>
#include <QWidget>

QT_BEGIN_NAMESPACE
class QGroupBox;
class QLabel;
class QTableWidget;
class QSpinBox;
class QComboBox;
class QCheckBox;
class QPushButton;
QT_END_NAMESPACE

class ListTab : public QWidget
{
    Q_OBJECT

public:
    ListTab(QWidget *parent = 0);

    int row_num;
    int number;
    int currentPosition;
    int switch_time;
    QTableWidget *table;
    QIcon *delIcon;
    QFileInfoList allFiles;
    QFileInfoList additionalImages;
    QSettings *settings;
    QLabel *countlabel;
    QLabel *imgpos_label;
    QLabel *scroll_label;
    QLabel *time_label;
    QLabel *img_order_label;
    QSpinBox *timeBox;
    QComboBox *pos_comboBox;
    QComboBox *order_comboBox;
    QCheckBox *onlynames_checkBox;
    QPushButton *startButton;
    //QPushButton *quitButton;
    QPushButton *clearButton;
    QPushButton *addButton;
    QList<int> random_number_list, linearList;
    QTimer* switchTimer;
    QFileInfoList load_and_show();

public slots:
    void tableFill();
    int setImage();
    void processStart(QString path, QString arg);
    QList<int> createRandomNumberList();

    void startButton_clicked();
    void on_onlynames_checkBox_stateChanged(int );
    void on_timeBox_valueChanged(int );
    void addButton_clicked();
    void on_table_cellDoubleClicked(int row, int column);
    void on_table_cellClicked(int row, int column);
    void clearButton_clicked();
    void on_pos_comboBox_currentIndexChanged(QString name);
    void order_comboBox_currentIndexChanged(QString name);
    void config_save();
    //void quitButton_clicked();
};

class settingTab : public QWidget
{
    Q_OBJECT

public:
    settingTab(QWidget *parent = 0);
    QStringList dirList;
    QSettings *settings;
    QPushButton *addFolderButton;
    QLabel *picFolders;
    QListWidget *folderListWidget;

private slots:
    void on_addFolderButton_clicked();
    /*{
         if (m_pListTab)
         {
              m_pListTab->load_and_show();
         }
    }*/
private:

    ListTab* m_pListTab;
};

class WallWindow : public QMainWindow
{
    Q_OBJECT

public:
    WallWindow();

    bool ispause;

    ListTab *listTab;
    settingTab *settTab;
    QSystemTrayIcon* trayIcon;
    QIcon *trayicon;
    QTabWidget *tabWidget;

public slots:
    void nextImage();
    void previousImage();
    void iconActivated(QSystemTrayIcon::ActivationReason reason);

protected:
    void hideEvent(QHideEvent * event);
    void closeEvent(QCloseEvent *event);
};

#endif // WALLWINDOW_H
